(*
    This file is part of the Collections project -
    which currently provides ternary search trees.
    
    Copyright (C) 2000 ANOQ of the Sun (alias Johnny Andersen).
    
    E-mail: anoq@HardcoreProcessing.com

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    As a special exception, if you do not do anything which is not in
    the spirit of the GNU Library General Public License, you are not
    required to physically compile this software into a separate library,
    since this is generally not possible with current Stanard ML compilers.
    However if you do something which is not in the spirit of the
    GNU Library General Public License you will have to follow the
    licence perpetually - thus disallowing you to use it for any
    commercial purposes at all.

    If you are interested in a warranty or commercial support for this
    software, contact Hardcore Processing <sales@HardcoreProcessing.com>
    for more information.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)


(* This is an implementation of a ternary search tree, as
   described in:
   Dr. Dobb's Journal, April 1998, "Ternary Search Trees"
   It's available online at:
   http://www.ddj.com/articles/1998/9804/9804a/9804a.htm
*)
signature TERNARY_TREE =
  sig
    type 'a t

    val empty : 'a t
    val lookup : 'a t -> string -> 'a option

    (* insert overwrites any previous data. *)
    val insert : 'a t -> string -> 'a -> 'a t
  end